<?php

class ElloLitePhotography_Customizer_Notify {

	private $recommended_actions;

	
	private $recommended_plugins;

	
	private static $instance;

	
	private $recommended_actions_title;

	
	private $recommended_plugins_title;

	
	private $dismiss_button;

	
	private $install_button_label;

	
	private $activate_button_label;

	
	private $ellolitephotography_deactivate_button_label;
	

	private $config;

	public static function init( $config ) {
		if ( ! isset( self::$instance ) && ! ( self::$instance instanceof ElloLitePhotography_Customizer_Notify ) ) {
			self::$instance = new ElloLitePhotography_Customizer_Notify;
			if ( ! empty( $config ) && is_array( $config ) ) {
				self::$instance->config = $config;
				self::$instance->setup_config();
				self::$instance->setup_actions();
			}
		}

	}
	
	public function setup_config() {

		global $ellolitephotography_customizer_notify_recommended_plugins;
		global $ellolitephotography_customizer_notify_recommended_actions;

		global $install_button_label;
		global $activate_button_label;
		global $ellolitephotography_deactivate_button_label;

		$this->recommended_actions = isset( $this->config['recommended_actions'] ) ? $this->config['recommended_actions'] : array();
		$this->recommended_plugins = isset( $this->config['recommended_plugins'] ) ? $this->config['recommended_plugins'] : array();

		$this->recommended_actions_title = isset( $this->config['recommended_actions_title'] ) ? $this->config['recommended_actions_title'] : '';
		$this->recommended_plugins_title = isset( $this->config['recommended_plugins_title'] ) ? $this->config['recommended_plugins_title'] : '';
		$this->dismiss_button            = isset( $this->config['dismiss_button'] ) ? $this->config['dismiss_button'] : '';

		$ellolitephotography_customizer_notify_recommended_plugins = array();
		$ellolitephotography_customizer_notify_recommended_actions = array();

		if ( isset( $this->recommended_plugins ) ) {
			$ellolitephotography_customizer_notify_recommended_plugins = $this->recommended_plugins;
		}

		if ( isset( $this->recommended_actions ) ) {
			$ellolitephotography_customizer_notify_recommended_actions = $this->recommended_actions;
		}

		$install_button_label    = isset( $this->config['install_button_label'] ) ? $this->config['install_button_label'] : '';
		$activate_button_label   = isset( $this->config['activate_button_label'] ) ? $this->config['activate_button_label'] : '';
		$ellolitephotography_deactivate_button_label = isset( $this->config['ellolitephotography_deactivate_button_label'] ) ? $this->config['ellolitephotography_deactivate_button_label'] : '';

	}

	
	public function setup_actions() {

		// Register the section
		add_action( 'customize_register', array( $this, 'ellolitephotography_plugin_notification_customize_register' ) );

		// Enqueue scripts and styles
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'ellolitephotography_customizer_notify_scripts_for_customizer' ), 0 );

		/* ajax callback for dismissable recommended actions */
		add_action( 'wp_ajax_quality_customizer_notify_dismiss_action', array( $this, 'ellolitephotography_customizer_notify_dismiss_recommended_action_callback' ) );

		add_action( 'wp_ajax_ti_customizer_notify_dismiss_recommended_plugins', array( $this, 'ellolitephotography_customizer_notify_dismiss_recommended_plugins_callback' ) );

	}

	
	public function ellolitephotography_customizer_notify_scripts_for_customizer() {

		//wp_enqueue_style('ellolitephotography-customizer-notify-css', get_stylesheet_uri());
		wp_enqueue_style('ellolitephotography-customizer-notify-css', get_template_directory_uri() . '/inc/customizer-notify/css/ellolitephotography-customizer-notify.css');


		wp_enqueue_style( 'ellolitephotography-plugin-install' );
		wp_enqueue_script( 'ellolitephotography-plugin-install' );
		wp_add_inline_script( 'ellolitephotography-plugin-install', 'var pagenow = "customizer";' );

		wp_enqueue_script( 'ellolitephotography-updates' );
		wp_enqueue_script('ellolitephotography-customizer-notify-js', get_template_directory_uri() . '/inc/customizer-notify/js/ellolitephotography-notify.js', array('jquery'), null, true);

		wp_localize_script(
			'ellolitephotography-customizer-notify-js', 'ElloLitePhotographyCustomizercompanionObject', array(
				'ellolitephotography_ajaxurl'            => esc_url(admin_url( 'admin-ajax.php' )),
				'ellolitephotography_template_directory' => esc_url(get_template_directory_uri()),
				'ellolitephotography_base_path'          => esc_url(admin_url()),
				'ellolitephotography_activating_string'  => __( 'Activating', 'ello-lite-photography' ),
			)
		);

	}

	
	public function ellolitephotography_plugin_notification_customize_register( $wp_customize ) {

		
		require get_template_directory() . '/inc/customizer-notify/ellolitephotography-notify-section.php';

		$wp_customize->register_section_type( 'ElloLitePhotography_Customizer_Notify_Section' );

		$wp_customize->add_section(
			new ElloLitePhotography_Customizer_Notify_Section(
				$wp_customize,
				'ElloLitePhotography-customizer-notify-section',
				array(
					'title'          => $this->recommended_actions_title,
					'plugin_text'    => $this->recommended_plugins_title,
					'dismiss_button' => $this->dismiss_button,
					'priority'       => 0,
				)
			)
		);

	}

	
	public function ellolitephotography_customizer_notify_dismiss_recommended_action_callback() {

		global $ellolitephotography_customizer_notify_recommended_actions;

		$action_id = ( isset( $_GET['id'] ) ) ? $_GET['id'] : 0;

		echo esc_html($action_id); 

		if ( ! empty( $action_id ) ) {

			
			if ( get_theme_mod( 'ellolitephotography_customizer_notify_show' ) ) {

				$ellolitephotography_customizer_notify_show_recommended_actions = get_theme_mod( 'ellolitephotography_customizer_notify_show' );
				switch ( $_GET['todo'] ) {
					case 'add':
						$ellolitephotography_customizer_notify_show_recommended_actions[ $action_id ] = true;
						break;
					case 'dismiss':
						$ellolitephotography_customizer_notify_show_recommended_actions[ $action_id ] = false;
						break;
				}
				echo esc_html($ellolitephotography_customizer_notify_show_recommended_actions);
				
			} else {
				$ellolitephotography_customizer_notify_show_recommended_actions = array();
				if ( ! empty( $ellolitephotography_customizer_notify_recommended_actions ) ) {
					foreach ( $ellolitephotography_customizer_notify_recommended_actions as $ellolitephotography_lite_customizer_notify_recommended_action ) {
						if ( $ellolitephotography_lite_customizer_notify_recommended_action['id'] == $action_id ) {
							$ellolitephotography_customizer_notify_show_recommended_actions[ $ellolitephotography_lite_customizer_notify_recommended_action['id'] ] = false;
						} else {
							$ellolitephotography_customizer_notify_show_recommended_actions[ $ellolitephotography_lite_customizer_notify_recommended_action['id'] ] = true;
						}
					}
					echo esc_html($ellolitephotography_customizer_notify_show_recommended_actions);
				}
			}
		}
		die(); 
	}

	
	public function ellolitephotography_customizer_notify_dismiss_recommended_plugins_callback() {

		$action_id = ( isset( $_GET['id'] ) ) ? $_GET['id'] : 0;

		echo esc_html($action_id); 

		if ( ! empty( $action_id ) ) {

			$ellolitephotography_lite_customizer_notify_show_recommended_plugins = get_theme_mod( 'ellolitephotography_customizer_notify_show_recommended_plugins' );

			switch ( $_GET['todo'] ) {
				case 'add':
					$ellolitephotography_lite_customizer_notify_show_recommended_plugins[ $action_id ] = false;
					break;
				case 'dismiss':
					$ellolitephotography_lite_customizer_notify_show_recommended_plugins[ $action_id ] = true;
					break;
			}
			echo esc_html($ellolitephotography_customizer_notify_show_recommended_actions);
		}
		die(); 
	}

}
